defmodule Reactivity.Mixfile do
  use Mix.Project

  def project do
    [app: :reactivity,
     version: "0.6.0",
     elixir: "~> 1.4",
      build_embedded: Mix.env == :prod,
      start_permanent: Mix.env == :prod,
      description: description(),
      package: package(),
      deps: deps(),
      name: "Reactive Elixir",
      source_url: "https://github.com/m1dnight/reactive-elixir"]
  end

  def application do
    # Specify extra applications you'll use from Erlang/Elixir
    [extra_applications: [:logger],
     mod: {Reactivity.Application, []}]
  end

  defp deps do
    [{:ex_doc, ">= 0.0.0", only: :dev}]
  end

  defp description do
    """
    A reactive programming library for Elixir. The purpose of this library is to experiment in an academic context.
    """
  end
  
  defp package do
    # These are the default files included in the package
    [
      name: :reactivity,
      files: ["lib", "mix.exs", "README*", "LICENSE*"],
      maintainers: ["Christophe De Troyer"],
      licenses: ["GPL3"],
      links: %{"GitHub" => "https://github.com/m1dnight/reactive-elixir"}
    ]
  end
end
